(DEFINE (DOMAIN restaurant)
(:REQUIREMENTS :TYPING :STRIPS )
(:TYPES 
PERSON FOOD LOCATION - OBJECT
CHEF GUEST WAITER - PERSON
)
(:PREDICATES
(WANTS ?P00 - PERSON ?F10 - FOOD)
(HAS ?P00 - PERSON ?F10 - FOOD)
(BE-FULL ?P00 - PERSON)
(AT ?L00 - LOCATION ?P10 - PERSON)
)
(:ACTION COOK
    :PARAMETERS (?CHEF - CHEF ?FOOD - FOOD)
    :PRECONDITION (WANTS ?CHEF ?FOOD)
    :EFFECT (AND (HAS ?CHEF ?FOOD)(NOT(WANTS ?CHEF ?FOOD)))
)

(:ACTION ORDER
    :PARAMETERS (?INTERLOCUTOR1 ?INTERLOCUTOR2 - PERSON ?FOOD - FOOD ?LOC - LOCATION)
    :PRECONDITION (AND (AT ?LOC ?INTERLOCUTOR1)
                       (AT ?LOC ?INTERLOCUTOR2)
                       (WANTS ?INTERLOCUTOR2 ?FOOD)
                  )
    :EFFECT (AND 
                (WANTS ?INTERLOCUTOR1 ?FOOD)
            )
)

(:ACTION EAT
    :PARAMETERS (?PERSON - PERSON ?FOOD - FOOD)
    :PRECONDITION (AND (HAS ?PERSON ?FOOD))
    :EFFECT (AND (NOT (HAS ?PERSON ?FOOD))
                 (BE-FULL ?PERSON)
            )
)

(:ACTION GOT-TO
    :PARAMETERS (?START ?DESTINATION - LOCATION ?NAME - WAITER)
    :PRECONDITION (AND (AT ?START ?NAME))
    :EFFECT (AND (NOT (AT ?START ?NAME))(AT ?DESTINATION ?NAME))
)

(:ACTION GIVE
    :PARAMETERS (?INTERLOCUTOR1 ?INTERLOCUTOR2 - PERSON ?FOOD - FOOD ?LOC - LOCATION)
    :PRECONDITION (AND (AT ?LOC ?INTERLOCUTOR1)
                       (AT ?LOC ?INTERLOCUTOR2)
                       (WANTS ?INTERLOCUTOR2 ?FOOD)
                       (HAS ?INTERLOCUTOR1 ?FOOD)
                  )
    :EFFECT (AND 
            (NOT (WANTS ?INTERLOCUTOR2 ?FOOD))
            (NOT (HAS ?INTERLOCUTOR1 ?FOOD))
            (HAS ?INTERLOCUTOR2 ?FOOD)
            )
)


)